var("x,y")



def zero_vel_c(a, L, l=1.6):
	lag = l_lag(a)
	f = x^2 + y^2 +2*((1-a)/sqrt((x+a)^2+y^2)+a/sqrt((x-1+a)^2+y^2))
	P = point([(0,0)],size=0)
	for k in L:
		c = f(x=lag[k][0], y=lag[k][1]) 
		P += implicit_plot(f-c, (x,-l,l), (y,-l,l), plot_points=400)
	return P


def l_lag(mu):
	lag = [0,0,0, ((1-2*mu)/2, sqrt(3)/2), ((1-2*mu)/2, -sqrt(3)/2) ]
	fu = (1-mu)*(x-1+mu)^2*((x+mu)^3-1)+mu*(x+mu)^2*((x-1+mu)^3+1)
	lag[0] = (find_root(fu, -mu,1-mu) ,0)

	fu = (1-mu)*(x-1+mu)^2*((x+mu)^3-1)+mu*(x+mu)^2*((x-1+mu)^3-1)
	lag[1] = (find_root(fu, 1-mu, 2) ,0)

	fu = (1-mu)*(x-1+mu)^2*((x+mu)^3+1)+mu*(x+mu)^2*((x-1+mu)^3+1)
	lag[2] = (find_root(fu, -2, -mu) , 0)
	
	return lag

def lag_p_m(mu):
	P = points([(0,0),(1,0)],size=10)
	P += point(l_lag(mu), size=60, color='red')
	P += point([(-mu,0), (1-mu,0)], size=60, color='green')
	return P


mmu = 0.1

for k in srange(3):
	P = lag_p_m(mmu)
	P += zero_vel_c(mmu,[k])
	P.set_aspect_ratio(1)
	P.axes(False)
	P.fontsize(20)
	P.save('../images/zvc'+str(k)+'.png')

P = lag_p_m(mmu)
P += zero_vel_c(mmu,range(3))
P.set_aspect_ratio(1)
P.axes(False)
P.fontsize(20)
P.save('../images/zvc.png')


mmu = 0.005

for k in srange(3):
	P = lag_p_m(mmu)
	P += zero_vel_c(mmu,[k])
	P.set_aspect_ratio(1)
	P.axes(False)
	P.fontsize(20)
	P.save('../images/zvc'+str(k)+'r.png')

P = lag_p_m(mmu)
P += zero_vel_c(mmu,range(3))
P.set_aspect_ratio(1)
P.axes(False)
P.fontsize(20)
P.save('../images/zvcr.png')


################################################


def zero_vel(mu, l=1.6):
	P = point([(0,0)],size=0)
	f = x^2 + y^2 +2*((1-mu)/sqrt((x+mu)^2+y^2)+mu/sqrt((x-1+mu)^2+y^2))
	cmin = f(x=(1-2*mu)/2, y=sqrt(3)/2)
	cmax = min( f(x=-l, y=0),f(x=0, y=-l) )
	N = 12
	h = (cmax-cmin)/N
	for c in srange(cmin+h/2, cmax, h):
		P += implicit_plot(f-c, (x,-l,l), (y,-l,l), plot_points=400)
	return P



Lmu = [0.5, 0.1, 0.05, 0.01]

for k in range(4):
	mmu = Lmu[k]
	P = lag_p_m(mmu)
	P += zero_vel(mmu)
	P.set_aspect_ratio(1)
	P.axes(False)
	P.fontsize(20)
	P.save('../images/zv'+str(k)+'.png')








